thf(t_nat,type,(nat : $tType)).
thf(t_one_n,type,(one_n : nat)).
thf(t_succ_n,type,(succ_n : (nat > nat))).
thf(a_succ_one,axiom,(! [M:nat] : ((succ_n @ M) != one_n))).
thf(a_succ_inj,axiom,(! [M:nat] : (! [N:nat] : (((succ_n @ M) = (succ_n @ N)) => (M = N))))).
thf(a_ind,axiom,(! [P:(nat > $o)] : ((P @ one_n) => ((! [M:nat] : ((P @ M) => (P @ (succ_n @ M)))) => (! [M:nat] : (P @ M)))))).

thf(t_plus_n,type,(plus_n : (nat > (nat > nat)))).
thf(t_mult_n,type,(mult_n : (nat > (nat > nat)))).
thf(a_plus_n_o,axiom,(! [M:nat] : ((plus_n @ M @ one_n) = M))).
thf(a_plus_n_s,axiom,(! [M:nat] : (! [N:nat] : ((plus_n @ M @ (succ_n @ N)) = (succ_n @ (plus_n @ M @ N)))))).
thf(a_mult_n_o,axiom,(! [M:nat] : ((mult_n @ M @ one_n) = M))).
thf(a_mult_n_s,axiom,(! [M:nat] : (! [N:nat] : ((mult_n @ M @ (succ_n @ N)) = (plus_n @ (mult_n @ M @ N) @ M))))).

thf(t_int,type,(int : $tType)).
thf(t_zero,type,(zero : int)).
thf(t_pos,type,(pos : (nat > int))).
thf(t_neg,type,(neg : (nat > int))).
thf(a_pos_zero,axiom,(! [M:nat] : ((pos @ M) != zero))).
thf(a_neg_zero,axiom,(! [M:nat] : ((neg @ M) != zero))).
thf(a_pos_neg,axiom,(! [M:nat] : ((pos @ M) != (neg @ M)))).
thf(a_pos_inj,axiom,(! [M:nat] : (! [N:nat] : (((pos @ M) = (pos @ N)) => (M = N))))).
thf(a_neg_inj,axiom,(! [M:nat] : (! [N:nat] : (((neg @ M) = (neg @ N)) => (M = N))))).
thf(a_int_cases,axiom,(! [M:int] : ((M = zero) | (? [N:nat] : (M = (pos @ N))) | (? [N:nat] : (M = (neg @ N)))))).
thf(t_plus,type,(plus : (int > (int > int)))).
thf(t_lt,type,(lt : (int > (int > $o)))).
thf(t_leq,type,(leq : (int > (int > $o)))).
thf(t_mult,type,(mult : (int > (int > int)))).
thf(t_diff,type,(diff : (int > (int > int)))).
thf(t_div,type,(div : (int > (int > int)))).
thf(t_mod,type,(mod : (int > (int > int)))).
thf(a_plus_com,axiom,(! [M:int] : (! [N:int] : ((plus @ M @ N) = (plus @ N @ M))))).
thf(a_plus_z,axiom,(! [M:int] : ((plus @ M @ zero) = M))).
thf(a_plus_pos_pos,axiom,(! [M:nat] : (! [N:nat] : ((plus @ (pos @ M) @ (pos @ N)) = (pos @ (plus_n @ M @ N)))))).
thf(a_plus_neg_neg,axiom,(! [M:nat] : (! [N:nat] : ((plus @ (neg @ M) @ (neg @ N)) = (neg @ (plus_n @ M @ N)))))).
thf(a_plus_pos_neg,axiom,(! [M:nat] : (! [N:nat] : ((? [K:nat] : (((plus_n @ M @ K) = N) & ((plus @ (pos @ M) @ (neg @ N)) = (neg @ K)))) | (? [K:nat] : (((plus_n @ N @ K) = M) & ((plus @ (pos @ M) @ (neg @ N)) = (pos @ K)))))))).
thf(a_lt_def,axiom,(! [M:int] : (! [N:int] : ((lt @ M @ N) <=> (? [K:nat] : ((plus @ M @ (pos @ K)) = N)))))).
thf(a_leq_def,axiom,(! [M:int] : (! [N:int] : ((leq @ M @ N) <=> (lt @ M @ (plus @ M @ (pos @ one_n))))))).
thf(a_mult_com,axiom,(! [M:int] : (! [N:int] : ((mult @ M @ N) = (mult @ N @ M))))).
thf(a_mult_z,axiom,(! [M:int] : ((mult @ M @ zero) = zero))).
thf(a_mult_pos_pos,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (pos @ M) @ (pos @ N)) = (pos @ (mult_n @ M @ N)))))).
thf(a_mult_neg_neg,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (neg @ M) @ (neg @ N)) = (pos @ (mult_n @ M @ N)))))).
thf(a_mult_pos_neg,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (pos @ M) @ (neg @ N)) = (neg @ (mult_n @ M @ N)))))).
thf(a_diff_def,axiom,(! [M:int] : (! [N:int] : (! [K:int] : (((diff @ M @ N) = K) <=> ((plus @ N @ K) = M)))))).
thf(a_div_mod_prop,axiom,(! [M:int] : (! [N:int] : ((lt @ zero @ N) => (! [Q:int] : (! [R:int] : ((((div @ M @ N) = Q) & ((mod @ M @ N) = R)) <=> ((leq @ zero @ R) & (lt @ R @ N) & ((plus @ (mult @ N @ Q) @ R) = M))))))))).
thf(t_prog,type,(prog2 : $tType)).
thf(t_ZERO,type,(p_ZERO : prog2)).
thf(t_ONE,type,(p_ONE : prog2)).
thf(t_TWO,type,(p_TWO : prog2)).
thf(t_ADDI,type,(p_ADDI : (prog2 > (prog2 > prog2)))).
thf(t_DIFF,type,(p_DIFF : (prog2 > (prog2 > prog2)))).
thf(t_MULT,type,(p_MULT : (prog2 > (prog2 > prog2)))).
thf(t_DIVI,type,(p_DIVI : (prog2 > (prog2 > prog2)))).
thf(t_MODU,type,(p_MODU : (prog2 > (prog2 > prog2)))).
thf(t_COND,type,(p_COND : (prog2 > (prog2 > (prog2 > prog2))))).
thf(t_LOOP,type,(p_LOOP : (prog2 > (prog2 > (prog2 > prog2))))).
thf(t_LOOP2,type,(p_LOOP2 : (prog2 > (prog2 > (prog2 > (prog2 > (prog2 > prog2))))))).
thf(t_X,type,(p_X : prog2)).
thf(t_Y,type,(p